<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Crazyflie plugin for ARGoS: src/plugins/robots/crazyflie/simulator/crazyflie_colored_blob_perspective_camera_default_sensor.cpp File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Crazyflie plugin for ARGoS
   </div>
   <div id="projectbrief">ADARS project -- PCOG / SnT / University of Luxembourg</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_7020b8b7abcceffa3f9f7a2d24718f16.html">plugins</a></li><li class="navelem"><a class="el" href="dir_57fbab4b29583c403f1efb5284ea3eb3.html">robots</a></li><li class="navelem"><a class="el" href="dir_82540c9fcfb987b606f5fb531cb7ce0a.html">crazyflie</a></li><li class="navelem"><a class="el" href="dir_8f67be75dbc917b3ef586b0672f32ede.html">simulator</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#namespaces">Namespaces</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">crazyflie_colored_blob_perspective_camera_default_sensor.cpp File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &quot;<a class="el" href="crazyflie__colored__blob__perspective__camera__default__sensor_8h_source.html">crazyflie_colored_blob_perspective_camera_default_sensor.h</a>&quot;</code><br />
<code>#include &lt;argos3/core/simulator/simulator.h&gt;</code><br />
<code>#include &lt;argos3/core/simulator/space/positional_indices/positional_index.h&gt;</code><br />
<code>#include &lt;argos3/core/simulator/entity/composable_entity.h&gt;</code><br />
<code>#include &lt;argos3/core/simulator/entity/embodied_entity.h&gt;</code><br />
<code>#include &lt;argos3/plugins/simulator/entities/led_entity.h&gt;</code><br />
<code>#include &lt;argos3/plugins/simulator/media/led_medium.h&gt;</code><br />
<code>#include &quot;<a class="el" href="crazyflie__camera__equipped__entity_8h_source.html">crazyflie_camera_equipped_entity.h</a>&quot;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for crazyflie_colored_blob_perspective_camera_default_sensor.cpp:</div>
<div class="dyncontent">
<div class="center"><img src="crazyflie__colored__blob__perspective__camera__default__sensor_8cpp__incl.png" border="0" usemap="#asrc_2plugins_2robots_2crazyflie_2simulator_2crazyflie__colored__blob__perspective__camera__default__sensor_8cpp" alt=""/></div>
<map name="asrc_2plugins_2robots_2crazyflie_2simulator_2crazyflie__colored__blob__perspective__camera__default__sensor_8cpp" id="asrc_2plugins_2robots_2crazyflie_2simulator_2crazyflie__colored__blob__perspective__camera__default__sensor_8cpp">
<area shape="rect" title=" " alt="" coords="975,5,1167,91"/>
<area shape="rect" href="crazyflie__colored__blob__perspective__camera__default__sensor_8h.html" title=" " alt="" coords="303,139,495,195"/>
<area shape="rect" title=" " alt="" coords="519,146,665,187"/>
<area shape="rect" title=" " alt="" coords="689,139,857,195"/>
<area shape="rect" title=" " alt="" coords="882,146,1062,187"/>
<area shape="rect" title=" " alt="" coords="1086,146,1253,187"/>
<area shape="rect" title=" " alt="" coords="1277,146,1440,187"/>
<area shape="rect" title=" " alt="" coords="1464,146,1627,187"/>
<area shape="rect" href="crazyflie__camera__equipped__entity_8h.html" title=" " alt="" coords="1651,146,1831,187"/>
<area shape="rect" title=" " alt="" coords="5,257,131,299"/>
<area shape="rect" title=" " alt="" coords="155,257,301,299"/>
<area shape="rect" title=" " alt="" coords="325,257,472,299"/>
<area shape="rect" title=" " alt="" coords="497,243,687,313"/>
<area shape="rect" title=" " alt="" coords="712,257,861,299"/>
<area shape="rect" title=" " alt="" coords="1403,257,1549,299"/>
<area shape="rect" title=" " alt="" coords="1573,250,1739,306"/>
<area shape="rect" title=" " alt="" coords="1763,257,1888,299"/>
<area shape="rect" title=" " alt="" coords="1912,257,2043,299"/>
</map>
</div>
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classargos_1_1CCrazyfliePerspectiveCameraLEDCheckOperation.html">argos::CCrazyfliePerspectiveCameraLEDCheckOperation</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="namespaces"></a>
Namespaces</h2></td></tr>
<tr class="memitem:namespaceargos"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceargos.html">argos</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a1b53c1127b6f64cfdf89fc17e614d8c1"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceargos.html#a1b53c1127b6f64cfdf89fc17e614d8c1">argos::REGISTER_SENSOR</a> (CCrazyflieColoredBlobPerspectiveCameraDefaultSensor, &quot;crazyflie_colored_blob_perspective_camera&quot;, &quot;default&quot;, &quot;Daniel H. Stolfi based on Carlo Pinciroli's work&quot;, &quot;1.0&quot;, &quot;A generic perspective camera sensor to detect colored blobs.&quot;, &quot;This sensor accesses an perspective camera that detects colored blobs. The\n&quot; &quot;sensor returns a list of blobs, each defined by a color and a position with\n&quot; &quot;respect to the robot reference point on the ground. In controllers, you must\n&quot; &quot;include the ci_colored_blob_perspective_camera_sensor.h header.\n\n&quot; &quot;This sensor is disabled by default, and must be enabled before it can be\n&quot; &quot;used.\n\n&quot; &quot;REQUIRED XML CONFIGURATION\n\n&quot; &quot;  &lt;controllers&gt;\n&quot; &quot;    ...\n&quot; &quot;    &lt;my_controller ...&gt;\n&quot; &quot;      ...\n&quot; &quot;      &lt;sensors&gt;\n&quot; &quot;        ...\n&quot; &quot;        &lt;colored_blob_perspective_camera implementation=\&quot;default\&quot;\n&quot; &quot;                                         medium=\&quot;leds\&quot; /&gt;\n&quot; &quot;        ...\n&quot; &quot;      &lt;/sensors&gt;\n&quot; &quot;      ...\n&quot; &quot;    &lt;/my_controller&gt;\n&quot; &quot;    ...\n&quot; &quot;  &lt;/controllers&gt;\n\n&quot; &quot;The 'medium' attribute must be set to the id of the leds medium declared in the\n&quot; &quot;&lt;media&gt; section.\n\n&quot; &quot;OPTIONAL XML CONFIGURATION\n\n&quot; &quot;It is possible to draw the rays shot by the camera sensor in the OpenGL\n&quot; &quot;visualization. This can be useful for sensor debugging but also to understand\n&quot; &quot;what's wrong in your controller. In OpenGL, the rays are drawn in cyan when\n&quot; &quot;they are not obstructed and in purple when they are. In case a ray is\n&quot; &quot;obstructed, a black dot is drawn where the intersection occurred.\n&quot; &quot;To turn this functionality on, add the attribute \&quot;show_rays\&quot; as in this\n&quot; &quot;example:\n\n&quot; &quot;  &lt;controllers&gt;\n&quot; &quot;    ...\n&quot; &quot;    &lt;my_controller ...&gt;\n&quot; &quot;      ...\n&quot; &quot;      &lt;sensors&gt;\n&quot; &quot;        ...\n&quot; &quot;        &lt;colored_blob_perspective_camera implementation=\&quot;default\&quot;\n&quot; &quot;                                         medium=\&quot;leds\&quot; /&gt;\n&quot; &quot;                                         show_rays=\&quot;true\&quot; /&gt;\n&quot; &quot;        ...\n&quot; &quot;      &lt;/sensors&gt;\n&quot; &quot;      ...\n&quot; &quot;    &lt;/my_controller&gt;\n&quot; &quot;    ...\n&quot; &quot;  &lt;/controllers&gt;\n\n&quot; &quot;It is possible to add uniform noise to the blobs, thus matching the\n&quot; &quot;characteristics of a real robot better. This can be done with the attribute\n&quot; &quot;\&quot;noise_std_dev\&quot;.\n\n&quot; &quot;  &lt;controllers&gt;\n&quot; &quot;    ...\n&quot; &quot;    &lt;my_controller ...&gt;\n&quot; &quot;      ...\n&quot; &quot;      &lt;sensors&gt;\n&quot; &quot;        ...\n&quot; &quot;        &lt;colored_blob_perspective_camera implementation=\&quot;default\&quot;\n&quot; &quot;                                         medium=\&quot;leds\&quot; /&gt;\n&quot; &quot;                                         noise_std_dev=\&quot;0.1\&quot; /&gt;\n&quot; &quot;        ...\n&quot; &quot;      &lt;/sensors&gt;\n&quot; &quot;      ...\n&quot; &quot;    &lt;/my_controller&gt;\n&quot; &quot;    ...\n&quot; &quot;  &lt;/controllers&gt;\n&quot;, &quot;Usable&quot;)</td></tr>
<tr class="separator:a1b53c1127b6f64cfdf89fc17e614d8c1"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
